#include "MainWindow.h"
#include "GLWindow.h"

MainWindow::MainWindow(
											 int _numSpheres,
                       QWidget *_parent
                      ):
                        QMainWindow(_parent)
{
    this->resize(QSize(1024,720));
    m_gl = new GLWindow(_numSpheres,this);
    this->setWindowTitle(QString("Ray Triangle Collision Detection %1 Triangles").arg(_numSpheres));
}

MainWindow::~MainWindow()
{
}


void MainWindow::keyPressEvent(
                               QKeyEvent *_event
                              )
{
	switch (_event->key())
  {
  case Qt::Key_Escape : QApplication::exit(EXIT_SUCCESS); break;
  case Qt::Key_F : showFullScreen(); break;
  case Qt::Key_N : showNormal(); break;
	}
	m_gl->processKey(_event);
}

void MainWindow::resizeEvent ( QResizeEvent * _event )
{
  m_gl->resize(_event->size());
}

